/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_Topwin (void)
{
  GtkWidget *Topwin;
  GtkWidget *vbox1;
  GtkWidget *hbox0;
  GtkWidget *label1;
  GtkWidget *combo1;
  GList *combo1_items = NULL;
  GtkWidget *combo_entry1;
  GtkWidget *hbox1;
  GtkWidget *aLow;
  GtkWidget *hbox11;
  GtkWidget *bLED1;
  GtkWidget *bLED2;
  GtkWidget *bLED3;
  GtkWidget *bLED4;
  GtkWidget *bLED5;
  GtkWidget *bLED6;
  GtkWidget *bLED7;
  GtkWidget *bLED8;
  GtkWidget *hbox12;
  GtkWidget *vseparator1;
  GtkWidget *bLowOn;
  GtkWidget *bLowOff;
  GtkWidget *hbox2;
  GtkWidget *aHigh;
  GtkWidget *hbox21;
  GtkWidget *bLED9;
  GtkWidget *bLED10;
  GtkWidget *bLED11;
  GtkWidget *bLED12;
  GtkWidget *bLED13;
  GtkWidget *bLED14;
  GtkWidget *bLED15;
  GtkWidget *bLED16;
  GtkWidget *hbox22;
  GtkWidget *vseparator3;
  GtkWidget *bHighOn;
  GtkWidget *bHighOff;
  GtkWidget *hbox3;
  GtkWidget *aWord;
  GtkWidget *bWordOn;
  GtkWidget *bWordOff;
  GtkWidget *aBlank;

  Topwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Topwin), "Topwin", Topwin);
  gtk_widget_set_usize (Topwin, 560, 160);
  gtk_window_set_title (GTK_WINDOW (Topwin), _("LED ON / OFF Control"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (Topwin), vbox1);

  hbox0 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox0);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox0", hbox0,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox0);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox0, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("Device: "));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox0), label1, FALSE, FALSE, 0);
  gtk_widget_set_usize (label1, 100, -2);

  combo1 = gtk_combo_new ();
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "combo1", combo1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo1);
  gtk_box_pack_start (GTK_BOX (hbox0), combo1, TRUE, TRUE, 0);
  combo1_items = g_list_append (combo1_items, _("/dev/dio"));
  combo1_items = g_list_append (combo1_items, _("/dev/dio1"));
  combo1_items = g_list_append (combo1_items, _("/dev/dio2"));
  combo1_items = g_list_append (combo1_items, _("/dev/dio3"));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
  g_list_free (combo1_items);

  combo_entry1 = GTK_COMBO (combo1)->entry;
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry1);
  gtk_entry_set_text (GTK_ENTRY (combo_entry1), _("/dev/dio"));

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  aLow = gtk_label_new (_(" Low byte"));
  gtk_widget_ref (aLow);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "aLow", aLow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (aLow);
  gtk_box_pack_start (GTK_BOX (hbox1), aLow, FALSE, FALSE, 0);

  hbox11 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (hbox1), hbox11, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox11, 200, -2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox11), 8);

  bLED1 = gtk_toggle_button_new_with_label (_("1"));
  gtk_widget_ref (bLED1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED1", bLED1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED1);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED1, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED1, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED1), 4);

  bLED2 = gtk_toggle_button_new_with_label (_("2"));
  gtk_widget_ref (bLED2);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED2", bLED2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED2);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED2, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED2, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED2), 4);

  bLED3 = gtk_toggle_button_new_with_label (_("3"));
  gtk_widget_ref (bLED3);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED3", bLED3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED3);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED3, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED3, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED3), 4);

  bLED4 = gtk_toggle_button_new_with_label (_("4"));
  gtk_widget_ref (bLED4);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED4", bLED4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED4);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED4, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED4, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED4), 4);

  bLED5 = gtk_toggle_button_new_with_label (_("5"));
  gtk_widget_ref (bLED5);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED5", bLED5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED5);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED5, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED5, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED5), 4);

  bLED6 = gtk_toggle_button_new_with_label (_("6"));
  gtk_widget_ref (bLED6);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED6", bLED6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED6);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED6, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED6, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED6), 4);

  bLED7 = gtk_toggle_button_new_with_label (_("7"));
  gtk_widget_ref (bLED7);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED7", bLED7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED7);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED7, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED7, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED7), 4);

  bLED8 = gtk_toggle_button_new_with_label (_("8"));
  gtk_widget_ref (bLED8);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED8", bLED8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED8);
  gtk_box_pack_start (GTK_BOX (hbox11), bLED8, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED8, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED8), 4);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (hbox1), hbox12, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox12, 100, -2);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox12), vseparator1, TRUE, TRUE, 0);

  bLowOn = gtk_button_new_with_label (_(" Low On"));
  gtk_widget_ref (bLowOn);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLowOn", bLowOn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLowOn);
  gtk_box_pack_start (GTK_BOX (hbox12), bLowOn, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bLowOn), 12);

  bLowOff = gtk_button_new_with_label (_(" Low Off"));
  gtk_widget_ref (bLowOff);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLowOff", bLowOff,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLowOff);
  gtk_box_pack_start (GTK_BOX (hbox12), bLowOff, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bLowOff), 12);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  aHigh = gtk_label_new (_("High byte"));
  gtk_widget_ref (aHigh);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "aHigh", aHigh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (aHigh);
  gtk_box_pack_start (GTK_BOX (hbox2), aHigh, FALSE, FALSE, 0);

  hbox21 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox21, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox21, 200, -2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox21), 8);

  bLED9 = gtk_toggle_button_new_with_label (_("9"));
  gtk_widget_ref (bLED9);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED9", bLED9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED9);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED9, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED9, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED9), 4);

  bLED10 = gtk_toggle_button_new_with_label (_("10"));
  gtk_widget_ref (bLED10);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED10", bLED10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED10);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED10, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED10, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED10), 4);

  bLED11 = gtk_toggle_button_new_with_label (_("11"));
  gtk_widget_ref (bLED11);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED11", bLED11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED11);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED11, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED11, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED11), 4);

  bLED12 = gtk_toggle_button_new_with_label (_("12"));
  gtk_widget_ref (bLED12);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED12", bLED12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED12);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED12, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED12, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED12), 4);

  bLED13 = gtk_toggle_button_new_with_label (_("13"));
  gtk_widget_ref (bLED13);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED13", bLED13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED13);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED13, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED13, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED13), 4);

  bLED14 = gtk_toggle_button_new_with_label (_("14"));
  gtk_widget_ref (bLED14);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED14", bLED14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED14);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED14, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED14, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED14), 4);

  bLED15 = gtk_toggle_button_new_with_label (_("15"));
  gtk_widget_ref (bLED15);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED15", bLED15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED15);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED15, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED15, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED15), 4);

  bLED16 = gtk_toggle_button_new_with_label (_("16"));
  gtk_widget_ref (bLED16);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bLED16", bLED16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bLED16);
  gtk_box_pack_start (GTK_BOX (hbox21), bLED16, FALSE, FALSE, 0);
  gtk_widget_set_usize (bLED16, 32, -2);
  gtk_container_set_border_width (GTK_CONTAINER (bLED16), 4);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox22, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbox22, 100, -2);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator3);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "vseparator3", vseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator3);
  gtk_box_pack_start (GTK_BOX (hbox22), vseparator3, TRUE, TRUE, 0);

  bHighOn = gtk_button_new_with_label (_("High On"));
  gtk_widget_ref (bHighOn);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bHighOn", bHighOn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bHighOn);
  gtk_box_pack_start (GTK_BOX (hbox22), bHighOn, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bHighOn), 12);

  bHighOff = gtk_button_new_with_label (_("High Off"));
  gtk_widget_ref (bHighOff);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bHighOff", bHighOff,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bHighOff);
  gtk_box_pack_start (GTK_BOX (hbox22), bHighOff, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bHighOff), 12);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  aWord = gtk_label_new (_("Word mode"));
  gtk_widget_ref (aWord);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "aWord", aWord,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (aWord);
  gtk_box_pack_start (GTK_BOX (hbox3), aWord, FALSE, FALSE, 16);

  bWordOn = gtk_button_new_with_label (_("Low-High On"));
  gtk_widget_ref (bWordOn);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bWordOn", bWordOn,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bWordOn);
  gtk_box_pack_start (GTK_BOX (hbox3), bWordOn, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bWordOn), 8);

  bWordOff = gtk_button_new_with_label (_("Low-High Off"));
  gtk_widget_ref (bWordOff);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "bWordOff", bWordOff,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bWordOff);
  gtk_box_pack_start (GTK_BOX (hbox3), bWordOff, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (bWordOff), 8);

  aBlank = gtk_label_new ("");
  gtk_widget_ref (aBlank);
  gtk_object_set_data_full (GTK_OBJECT (Topwin), "aBlank", aBlank,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (aBlank);
  gtk_box_pack_start (GTK_BOX (hbox3), aBlank, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (Topwin), "delete_event",
                      GTK_SIGNAL_FUNC (on_Topwin_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (combo_entry1), "changed",
                      GTK_SIGNAL_FUNC (on_combo_entry1_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED1), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED2), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED3), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED3_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED4), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED4_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED5), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED5_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED6), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED6_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED7), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED7_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED8), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED8_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLowOn), "clicked",
                      GTK_SIGNAL_FUNC (on_bLowOn_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLowOff), "clicked",
                      GTK_SIGNAL_FUNC (on_bLowOff_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED9), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED9_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED10), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED10_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED11), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED11_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED12), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED12_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED13), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED13_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED14), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED14_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED15), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED15_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bLED16), "toggled",
                      GTK_SIGNAL_FUNC (on_bLED16_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bHighOn), "clicked",
                      GTK_SIGNAL_FUNC (on_bHighOn_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bHighOff), "clicked",
                      GTK_SIGNAL_FUNC (on_bHighOff_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bWordOn), "clicked",
                      GTK_SIGNAL_FUNC (on_bWordOn_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bWordOff), "clicked",
                      GTK_SIGNAL_FUNC (on_bWordOff_clicked),
                      NULL);

  return Topwin;
}

