/*
 * Gladeκmain.cեǤ. ԽɬפǤ.
 * GladeϤΥե񤭤ޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"

/* ============================================== */
#include <fcntl.h>

int dio_init(void);
int dio_exit(void);
int dio_write(char *cmd);
int dio_read(void);

void DevNameChanged(char *str);

void  Relay( short BitData, short OnOff );

static char  dio_dev[20] = "\0";
static int      Card_fd;

int
dio_init()
{
    char  *sWrtCtrl = "WrtCtrl:0x03\n";           /* mode = low & high output mode */
    char  *sWrtMask = "WrtMask:0x00\n";    /* Int disable */

    if (dio_dev[0] == '\0') {
        strcpy(dio_dev, "/dev/dio");
    }

    Card_fd = open(dio_dev, O_RDWR);
    if (Card_fd == -1) {
        g_print("open error ...\n");
        return (-1);
    }

  g_print("open : %s\n", dio_dev);

     /* Set Contorl */
    if ( write(Card_fd, sWrtCtrl, strlen(sWrtCtrl)) == -1) {
        g_print("%s %s error...\n", dio_dev, sWrtCtrl);
        return (-1);
    }

     /* Set Int mask */
    if ( write(Card_fd, sWrtMask, strlen(sWrtMask)) == -1) {
        g_print("%s %s error...\n", dio_dev, sWrtMask);
        return (-1);
    }


  return 0;
}  /* dio_init */

int
dio_exit()
{
  if (Card_fd == -1)
    return -1;

  g_print("dio_exit : start\n");
  close(Card_fd);

  g_print("close : %s\n", dio_dev);
  return 0;
}

int
dio_write(char *cmd)
{
  int  wlen, len;

  if (Card_fd == -1)
    return -1;

  wlen = strlen(cmd);
  len = write(Card_fd, cmd, wlen);
  if (len == -1) {
      g_print("write error...:[%d] %s\n", wlen, cmd);
      return (-1);
  }

  g_print("write : %s\n", cmd);
  return 0;

}  /* dio_write */

void
DevNameChanged(char *new )
{
    dio_exit();
    strcpy( dio_dev, new);
    dio_init();
}

/* =========================================== */

int
main (int argc, char *argv[])
{
  GtkWidget *Topwin;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gnome_init ("gtkex2", VERSION, argc, argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  Topwin = create_Topwin ();
  gtk_widget_show (Topwin);

  dio_init();	/* Initializing REX=5055 */

  gtk_main ();
  return 0;
}

